#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion
using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;
using Syncfusion.Pdf.Shared;
using Syncfusion.Pdf;
using Syncfusion.HtmlConverter;

namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.CheckBox chkImageType;
		private System.Windows.Forms.Button btnLoad;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtUrl;
		 private HtmlConverter m_converter;
		private System.Windows.Forms.OpenFileDialog dlgOpen;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.chkImageType = new System.Windows.Forms.CheckBox();
			this.btnLoad = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.txtUrl = new System.Windows.Forms.TextBox();
			this.dlgOpen = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(160, 56);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(152, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Generate PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// chkImageType
			// 
			this.chkImageType.Checked = true;
			this.chkImageType.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkImageType.Location = new System.Drawing.Point(48, 56);
			this.chkImageType.Name = "chkImageType";
			this.chkImageType.TabIndex = 7;
			this.chkImageType.Text = "Use Metafile";
			// 
			// btnLoad
			// 
			this.btnLoad.Location = new System.Drawing.Point(288, 16);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.Size = new System.Drawing.Size(32, 23);
			this.btnLoad.TabIndex = 6;
			this.btnLoad.Text = "...";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click_1);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(10, 18);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 23);
			this.label1.TabIndex = 4;
			this.label1.Text = "URL:";
			// 
			// txtUrl
			// 
			this.txtUrl.Location = new System.Drawing.Point(50, 18);
			this.txtUrl.Name = "txtUrl";
			this.txtUrl.Size = new System.Drawing.Size(232, 20);
			this.txtUrl.TabIndex = 5;
			this.txtUrl.Text = "http://www.codeproject.com/";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 94);
			this.Controls.Add(this.chkImageType);
			this.Controls.Add(this.btnLoad);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.txtUrl);
			this.Controls.Add(this.button1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Convert();
		}
		protected override void OnClosing(CancelEventArgs e)
		{
			base.OnClosing (e);

			if( m_converter != null )
			{
				m_converter.Dispose();
				m_converter = null;
			}
		}

   
		private string ToPDF( Image img )
		{
			PDFDocument doc = new PDFDocument();
			doc.Compression = CompressionLevel.NoCompression;
		
			IPDFGraphicState properties = doc.CreateGraphicState();
			properties.SplitImages = true;
			properties.BreakBehavior = AutoBreakBehavior.Cropping;	
			if( img != null )
			{
				doc.Margins.All = 0;
				SizeF dest=new SizeF();
				if (img.Width >doc.LastPage.DrawingWidth)
				{
					dest = new SizeF( doc.LastPage.DrawingWidth, -1 );
				}
				else
				{
					 dest= img.Size;
				}
				doc.LastPage.Graphics.DrawImage( PointF.Empty, img, dest, properties );
	
			}
			string path = "htmltopdf.pdf";
			doc.Save( path );

			return path;
		}

		private void Convert()
		{
			using( HtmlConverter html = new HtmlConverter() )
			{
				m_converter = html;
				string path;
        
				using( Image bmp = html.ConvertToImage( txtUrl.Text, GetImageType() ) )
				{
					path = ToPDF( bmp );
				}
        
				m_converter = null;

				string question = "Do you want to view the PDF file?";
        
				if( MessageBox.Show( question, "PDF File Created",
					MessageBoxButtons.YesNo, MessageBoxIcon.Information )
					== DialogResult.Yes )
				{
					Process.Start( path );
					this.Close();
				}
				else
				{
					this.Close();
				}
			}
		}
		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			if( dlgOpen.ShowDialog() == DialogResult.OK )
			{
				txtUrl.Text = dlgOpen.FileName;
        
			}
		}
		private ImageType GetImageType()
		{
			return ( chkImageType.Checked ) ? ImageType.Metafile : ImageType.Bitmap;
		}

		private void btnLoad_Click_1(object sender, System.EventArgs e)
		{
			if( dlgOpen.ShowDialog() == DialogResult.OK )
			{
				txtUrl.Text = dlgOpen.FileName;
        
			}
		}

		

	}
}
